Revit API 楼板开洞】的更多相关文章

start [Transaction(TransactionMode.Manual)] [Regeneration(RegenerationOption.Manual)] , , ) *  / , -, ) *  / , -, ) *  / , , ) *  / ).XYZPoint;             }         }         ), list.ElementAt()) )             {                 , , -)) < 0.01)//数值在0…
一.前言         应该是第二次写关于Revit API的博文了.虽然在BIM企业中工作,从事桌面BIM软件开发,但是我是不怎么喜欢写Revit API相关的代码.平时更多的是在写界面展示,架构维护,授权验证这块.为什么不喜欢Revit API呢?其实Autodesk封装的这套API是不错的(我在之后的工作中用起来挺舒服的),可能还是人比较懒吧,老查英文的API手册有点烦,而且这手册界面让我想起了上学时帮导师写ObjectARX的痛苦经历... 吐槽完之后,开始上干货.为什么需要去判断梁构…
查看 Revit API.发现有Element::IsHidden这个方法.通过UI创建一个element,注意要使得这个element在某些视图可见,但是在另一些视图不可见.运行下面的方法,你会发现几乎所有的视图都会返回true,这个结果并不是我们想要的. public void ishide() { Element elem = Document.GetElement()); FilteredElementCollector fec = new FilteredElementCollecto…
1.获取共享参数 private string GetSharInfo(Autodesk.Revit.ApplicationServices.Application revitApp) { StringBuilder str = new StringBuilder(); DefinitionFile definitionFile = revitApp.OpenSharedParameterFile(); DefinitionGroups groups = definitionFile.Group…
Revit API提供根据射线来寻找经过的元素.方法是固定模式,没什么好说.关键代码:doc.FindReferencesWithContextByDirection(ptStart, (ptEnd - ptStart), view3d) );         XYZ ptEnd = curve.get_EndPoint();         , , 0.01);//向量偏移的方法,这里向下偏移.         ptStart = ptStart - offset;         ptEnd…
在Revit API中加载族可以使用Doc.LoadFamily方法,传入要加载的族文件路径名,但是这种方式有一种缺点,就是如果族文件在当前工程中没有加载的话则返回成功,如果已经加载过,则返回失败,也就是拿不到FamilySymbol实例,而根据族生成实例图元又需要这个FamilySymbol.网上看到有些帖子说可以传入IFamilyLoadOptions实例就可以,但是笔者多次尝试,该方法均没有成功,始终返回失败,无奈放弃这种方法,改为在当前工程中查找该族是否加载过,如果加载则直接返回Fami…
开洞信息数据: ]);             ;                     ;                     ;                     ;                     , , ) * (dHeigh /  + iUp) /  + iLeft) / , , -) * (dHeigh /  + iDown) /  + iRight) / ;         ;         ) - lCurve.Curve.get_EndPoint();  …
涉及向量计算,求相交等相关技术. )                 {                     foreach (Face face in solid.Faces)                     {                         PlanarFace pf = face as PlanarFace;                         if (pf != null)                         {           …
[Transaction(TransactionMode.Manual)] [Regeneration(RegenerationOption.Manual)] public class cmd20120604 : IExternalCommand {     public Result Execute(ExternalCommandData cmdData, ref string messages, ElementSet elements)     {         UIDocument ui…
Revit内置了一些命令,直接调用Revit操作方式. 可以去API文档查询PostableCommand枚举,还是很多的. 话不多说,直接上代码 var commandId = RevitCommandId.LookupPostableCommandId(PostableCommand.LineStyles); if (app.CanPostCommand(commandId)) { app.PostCommand(commandId); }…
在Revit中有一个相机功能可以以相机视角产生一个视图.一开始我在Revit2016的API文档中找关键词Camera,但是没什么收获. 其实这个相机功能的真正核心是创建透视视图:View3D.CreatePerspective(Document, ElementId) 简单的代码示例如下: var uiDocument = commandData.Application.ActiveUIDocument;var doc = uiDocument.Document;IEnumerable<Vie…
OwnerFamily即族模板.获取类别的方法:Document.Settings.Categories.get_Item(BuiltInCategory.OST_Columns); //判断是不是柱族模板 [TransactionAttribute(Autodesk.Revit.Attributes.TransactionMode.Manual)] public class cmdCheckFamily : IExternalCommand {     bool ValidateDocumen…
由于Revit的版本问题,在网上找的生成墙图元的代码,在我机器上的Revit 2016中编译不能通过,通过多次调试,终于找到在revit 2016中使用API生成墙图元的代码,现在贴出来. 下面的代码在Revit 2016 + VS2013的环境下通过. class CreateWall : IExternalCommand { public static Document RevitDoc; public static Autodesk.Revit.ApplicationServices.Ap…
  [Transaction(TransactionMode.Manual)] [Regeneration(RegenerationOption.Manual)] public class cmd : IExternalCommand {     public Result Execute(ExternalCommandData cmdData, ref string msg, ElementSet elements)     {         UIDocument uiDoc = cmdDa…
//过滤选择,加上过滤条件,没有看出来差别. [TransactionAttribute(Autodesk.Revit.Attributes.TransactionMode.Manual)] public class cmd : IExternalCommand {     public Result Execute(ExternalCommandData commandData, ref string messages, ElementSet elements)     {         U…
start ;             )                 {                     eId = item;                 }             }             tag = doc.get_Element(eId) as IndependentTag;         }         catch (Exception)         {             ts.Dispose();             retu…
start [Transaction(TransactionMode.Manual)] [Regeneration(RegenerationOption.Manual)] );             Solid roomSolid = geoObject as Solid;             //计算质心             XYZ centriod = roomSolid.ComputeCentroid();             //下降             XYZ roo…
>ADN: DEVR3894  >ADN service level: Professional  >产品:Revit MEP 2012  >版本:2012  >语言:中文  >操作系统:window7 64bit  >联系电话:137xxxx1960 >问题标题:关于修改元素参数的问题? >问题内容:  上次提问,关于遍历链接文档创建空间的问题. 最终解决办法是:在链接文档的时候选择“原点到原点” 失败的原因就是坐标系没有对正. 这次的问题如下: 我…
1. Door在Revit里面的element类型是FamilyInstance. 2. Door在Revit里面的category类型是OST_Doors. 3. 想要过滤特定类型的element需要ElementClassFilter. 4. 想要过滤特定类型的category需要ElementCategoryFilter. 5. 想要让两种类型的filter同时起作用需要LogicalAndFilter. 6. 找到文档(Document)里的element需要FilteredElemen…
public IList<Element> findElementsByCategory(Autodesk.Revit.UI.UIApplication aApp, Document aDoc, BuiltInCategory ACategory) { FilteredElementCollector collector = new FilteredElementCollector(aDoc).OfCategory( ACategory).WhereElementIsNotElementTyp…
using System; using System.Collections.Generic; using System.Linq; using System.Text; using System.Threading.Tasks; using Autodesk.Revit.Attributes; using Autodesk.Revit.DB; using Autodesk.Revit.UI; using Autodesk.Revit.DB.Architecture; namespace Cre…
using System; using System.Collections.Generic; using System.Linq; using System.Text; using System.Threading.Tasks; using Autodesk.Revit.UI; using Autodesk.Revit.DB; using Autodesk.Revit.Attributes; using Autodesk.Revit.ApplicationServices; namespace…
Revit中没有分割墙体的直接方法,一般采用调整原墙体的长度,再复制自身,调整复制体的长度.话不多说,直接上代码 public static void WallCopy(Document doc, XYZ sp, XYZ ep, Element wall) { XYZ origin = sp; List<ElementId> wallcopiesID = new List<ElementId>(); wallcopiesID = ElementTransformUtils.Copy…
话不多说,直接代码 var doc = commandData.Application.ActiveUIDocument.Document; FilteredElementCollector linkInstances = new FilteredElementCollector(doc); linkInstances = linkInstances.WherePasses(new ElementClassFilter(typeof(RevitLinkInstance))); if (linkI…
话不多说,直接上代码! public class WorkSetHelper { public void AddElementsToWorkSet(Document doc, List<Element> elements) { if (doc.IsWorkshared == true) { var workset = GetWorkset(doc); if (workset != null) { var worksetID = workset.Id.IntegerValue; using (T…
start [Transaction(TransactionMode.Manual)] [Regeneration(RegenerationOption.Manual)] public class cmd : IExternalCommand {     public Result Execute(ExternalCommandData cmdData, ref string msg, ElementSet elements)     {         UIDocument uiDoc = c…
start [Transaction(TransactionMode.Manual)] [Regeneration(RegenerationOption.Manual)] );//设置房间边界         }         ts.Commit();         return Result.Succeeded;     }     /// <summary>     /// 取得链接文件路径     /// </summary>     /// <param name…
用法:txt.Text=UnitConvertC.CovertFromAPI(param.AsDouble());param.Set(UnitConvertC.CovertToAPI(txt.Text)); Parameter parameter = item.get_Parameter(BuiltInParameter.ROOM_DESIGN_COOLING_LOAD_PARAM); if (null != parameter) {     coolingDesign += UnitConve…
start [Transaction(TransactionMode.Manual)] [Regeneration(RegenerationOption.Manual)] ].Origin, listConn0[].Origin);             Line line1 = Line.get_Bound(listConn1[].Origin, listConn1[].Origin);             )););         XYZ endPoint0 = line0.get_…
start ] ;);                 if (xyzStart.X > pb.Max.X || xyzStart.Y < pb.Max.Y)                     bWhile = false;                 else                     listXYZ.Add(xyzStart);             }             //批量布置             List<ACreat.FamilyIns…